/* THIS SAMPLE CODE IS PROVIDED AS IS AND IS SUBJECT TO ALTERATIONS. FUJITSU */
/* MICROELECTRONICS ACCEPTS NO RESPONSIBILITY OR LIABILITY FOR ANY ERRORS OR */
/* ELIGIBILITY FOR ANY PURPOSES.                                             */
/*                 (C) Fujitsu Microelectronics Europe GmbH                  */
/*---------------------------------------------------------------------------*/

#include <mcu.h>

#include "can.h"        /* include all CAN-Functions */


/*===========================================================================*/

void InitCan0()
{
  //
  // init CAN 0
  //
  FM3_GPIO->PFR3 |= (1 << 0x04) | (1 << 0x05);  // P34->TX0_1, P35->RX0_1     
  FM3_GPIO->EPFR09 |= (1 << 27)| (1 << 25);     // Use RX0_1 and Tx0_1          
    
  FM3_CAN0->CTRLR = 0x0041;                    // =>
  FM3_CANPRES->CANPRE=0x01;  
  // CTRLR0_Init = 1;               // CAN in init mode
  // CTRLR0_CCE = 1;                // allow to change BTR
  FM3_CAN0->BTR =  BTR_144M_100k_20_70_3;       // set BTR   
  FM3_CAN0->CTRLR = 0x0000;                    // =>
  // CTRLR0_CCE = 0;                // forbid to change BTR
  // CTRLR0_Init = 0;               // CAN in operation mode
  
  
  //
  // Init message buffer 1: transmit ID = 2(IF 1 CAN 0)
  //  
  FM3_CAN0->IF1CMSK = 0x00B3;                // set no transmit request, wr  

  FM3_CAN0->IF1ARB = 0xA0080000;     // ID = 2   => 0xA0080000       id4 = 0xA0100000;
    //IF1ARB20_MsgVal = 1;         // msg buffer valid
    //IF1ARB20_DIR = 1;            // direction = transmit
    // ID = 4                       // ID = 4
  
  FM3_CAN0->IF1MCTR = 0x0081;                  // =>
    //  IF1MCTR0_EoB = 1;           // end of buffer = 1 
    //  IF1MCTR0_DLC = 1;           // data length = 1 byte

  FM3_CAN0->IF1CREQ = 1;                     // transfer IF Register 2 to message buffer 2   
  
  /*
   //
  // Init message buffer 1: transmit ID = 4(IF 1 CAN 0)
  //  
  FM3_CAN0->IF1CMSK = 0x00B3;                // set no transmit request, wr  

  FM3_CAN0->IF1ARB = 0xA0100000;     // ID = 2   => 0xA0080000       id4 = 0xA0100000;
    //IF1ARB20_MsgVal = 1;         // msg buffer valid
    //IF1ARB20_DIR = 1;            // direction = transmit
    // ID = 4                       // ID = 4
  
  FM3_CAN0->IF1MCTR = 0x0081;                  // =>
    //  IF1MCTR0_EoB = 1;           // end of buffer = 1 
    //  IF1MCTR0_DLC = 1;           // data length = 1 byte

  FM3_CAN0->IF1CREQ = 4;                     // transfer IF Register 2 to message buffer 2   
  
  */
  
  //
  // Init message buffer 2: receive ID=2 (IF 2 CAN 0)
  //       
  FM3_CAN0->IF2CMSK = 0x00B3;                // set no transmit request, wr
  
  FM3_CAN0->IF2ARB = 0x80080000;             //id=2 0x80080000;
    // IF2ARB20_MsgVal = 1;         // msg buffer valid
    // IF2ARB20_DIR = 0;            // direction = receive
    // ID = 2                       // ID = 2
  
  FM3_CAN0->IF2MCTR = 0x0081;                // =>
   //  IF1MCTR0_EoB = 1;           // end of buffer = 1 
   //  IF1MCTR0_DLC = 1;           // data length = 1 byte
   
  FM3_CAN0->IF2CREQ = 2;                     // transfer IF Register 2 to message buffer 2
 
  FM3_CAN0->IF2CMSK = 0x0033;                // set no transmit request, rd   
  
  /*
    //
  // Init message buffer 2: receive ID=4 (IF 2 CAN 0)
  //       
  FM3_CAN0->IF2CMSK = 0x00B3;                // set no transmit request, wr
  
  FM3_CAN0->IF2ARB = 0x80100000;             //id=2 0x80080000;
    // IF2ARB20_MsgVal = 1;         // msg buffer valid
    // IF2ARB20_DIR = 0;            // direction = receive
    // ID = 2                       // ID = 2
  
  FM3_CAN0->IF2MCTR = 0x0081;                // =>
   //  IF1MCTR0_EoB = 1;           // end of buffer = 1 
   //  IF1MCTR0_DLC = 1;           // data length = 1 byte
   
  FM3_CAN0->IF2CREQ = 8;                     // transfer IF Register 2 to message buffer 2
 
  FM3_CAN0->IF2CMSK = 0x0033;                // set no transmit request, rd   
  */
}
